def tick args
  args.state.center_body  ||= [640 - 100, 360 - 100, 200, 200]
  args.state.other_bodies ||= 800.map { [1280 * rand, 720 * rand, 10, 10] }
  collisions = args.state.other_bodies.find_all { |b| b.intersects_rect? args.state.center_body }
  args.borders << args.state.center_body
  args.solids  << [args.state.center_body, 255, 0, 0, collisions.length * 5]
  args.solids  << args.state.other_bodies
  args.labels  << [10, 30, args.gtk.current_framerate]
  args.state.other_bodies.each do |b|
    b.x += 5
    b.y += 5
    b.x = 0 if b.x > 1280
    b.y = 0 if b.y > 720
  end
end

$gtk.reset
