# Similarly, whether rects intersect can be found through
# rect1.intersects_rect? rect2

def tick args
  x = 460

  args.outputs.labels << small_label(args, x, 3, "Click anywhere on the screen")
  # red_box = [460, 250, 355, 90, 170, 0, 0]
  # args.outputs.borders << red_box

  # args.game.box_collision_one and args.game.box_collision_two
  # Are given values of a solid when they should be rendered
  # They are stored in game so that they do not get reset every tick
  if args.inputs.mouse.click
    if !args.game.box_collision_one
      args.game.box_collision_one = [args.inputs.mouse.click.point.x - 25, args.inputs.mouse.click.point.y - 25, 125, 125, 180, 0,   0, 180]
    elsif !args.game.box_collision_two
      args.game.box_collision_two = [args.inputs.mouse.click.point.x - 25, args.inputs.mouse.click.point.y - 25, 125, 125,   0, 0, 180, 180]
    else
      args.game.box_collision_one = nil
      args.game.box_collision_two = nil
    end
  end

  if args.game.box_collision_one
    args.outputs.solids << args.game.box_collision_one
  end

  if args.game.box_collision_two
    args.outputs.solids << args.game.box_collision_two
  end

  if args.game.box_collision_one && args.game.box_collision_two
    if args.game.box_collision_one.intersects_rect? args.game.box_collision_two
      args.outputs.labels << small_label(args, x, 4, 'The boxes intersect.')
    else
      args.outputs.labels << small_label(args, x, 4, 'The boxes do not intersect.')
    end
  else
    args.outputs.labels << small_label(args, x, 4, '--')
  end
end

def small_label args, x, row, message
  [x, row_to_px(args, row), message, small_font]
end

def small_font
  [-2, 0, 0, 0, 0, 255]
end

def row_to_px args, row_number
  args.grid.top.shift_down(5).shift_down(20 * row_number)
end
